{ (C) 2001 Marek Wodzinski
 This code is licensed under GNU GPL
 File version: 1.2
 Last modification: Tue Sep 25 17:53:09 2001

 Changes:
 1.1 -> 1.2: added -a switch
 1.0 -> 1.1: reverse dumping order to 'natural'
}

uses rex;

var
  db,i:word;
  k:integer;
  t:text;
  pp,qq:twdbnr;
  s:string;

procedure dump_field(var tf:text;buf:twbufor;chars:longint);
var
  i:longint;
begin
  for i:=0 to chars-1 do
    if (buf^[i]<32) or (buf^[i]>127) then write(tf,'\x',hexstr(buf^[i],2))
      else write(tf,chr(buf^[i]));
end;

procedure dump_database(var tf:text;db:word);
var
  page,len:word;
  dbtypes,tt:twdbtype;
  dbrecords,rr,ee:twdbrecord;
  pom:tdbrecord;
  index:integer;
begin
  writeln(stderr,'find...');
  find_db(db,dbtypes,page);
  writeln(stderr,'read...');
  read_db(page,dbrecords);
  
  writeln(stderr,'dumping...');
  
  writeln(tf,'ApplicationName:Etc_Data');
  writeln(tf,'DBID:',db);
  tt:=dbtypes;
  while tt<>nil do
  begin
    write(tf,fieldtostr(tt^.typ));
    if tt^.next<>nil then write(tf,#9);
    tt:=tt^.next;
  end;
  writeln(tf);

  //reversing list order
  ee:=dbrecords;
  rr:=nil;
  while ee<>nil do
  begin
    pom.next:=rr;
    pom.size:=ee^.size;
    pom.data:=ee^.data;
    new(rr);
    rr^:=pom;
    pom.next:=ee;
    ee:=ee^.next;
    dispose(pom.next);
  end;
  
  dbrecords:=rr;
  while rr<>nil do
  begin
    tt:=dbtypes;
    index:=0;
    while tt<>nil do
    begin
      case tt^.typ of
	    1: begin  //DB_INT8(01)
		 write(tf,byte(rr^.data^[index]));
		 inc(index);
	       end;
	    2: begin  //DB_INT16(02)
		 write(tf,word(rr^.data^[index]+256*rr^.data^[index+1]));
		 inc(index,2);
	       end;
	    3: begin  //DB_INT32(03)
		 write(tf,cardinal(rr^.data^[index]+256*rr^.data^[index+1]+65536*rr^.data^[index+2]+16777216*rr^.data^[index+3]));
		 inc(index,4);
	       end;
	    11: begin  //DB_FXDSTR(0B)
		  index:=index+tt^.size;
		  //write('fxstr(',tt^.size,')...');
		  dump_field(tf,rr^.data,tt^.size);
		end;
	    12: begin  //DB_FXDDAT(0C)
		  index:=index+tt^.size;
		  //write('fxdat(',tt^.size,')...');
		  dump_field(tf,rr^.data,tt^.size);
		end;
	    21: begin  //DB_VARSTR(15)
		  len:=rr^.data^[index]+256*rr^.data^[index+1];
		  dump_field(tf,@rr^.data^[index+2],len);
		  index:=index+2+len;
		end;
	    22: begin  //DB_VARDAT(16)
		  len:=rr^.data^[index]+256*rr^.data^[index+1];
		  dump_field(tf,@rr^.data^[index+2],len);
		  index:=index+2+len;
		  //write('vardat(',len,')...');
		end;
	    90: begin  //DB_RECID(5A)
		  write(tf,cardinal(rr^.data^[index]+256*rr^.data^[index+1]+65536*rr^.data^[index+2]+16777216*rr^.data^[index+3]));
		  inc(index,4);
		end;
      end;
      if tt^.next<>nil then write(tf,#9);
      tt:=tt^.next;
    end;
    writeln(tf);
    rr:=rr^.next;
  end;
  //readln;
  writeln(stderr,'destroy db...');
  destroy_db_records(dbrecords);
  writeln(stderr,'destroy types...');
  destroy_db_type(dbtypes);
end;

begin
  if (paramcount<2) then
  begin
    writeln(stderr,'Usage: rexdbdump device db_id [db_id]...');
    writeln(stderr,'   or: rexdbdump device -a directory');
    writeln(stderr,'Messages are sent to stderr, database content to stdout');
    writeln(stderr,'With -a option there all databases from rex are written to specified directory');
    halt(1);
  end;
  if not open_rex(paramstr(1)) then halt(1);
  if (paramcount=3) and (paramstr(2)='-a') then
  begin
    //dumping all databases
    
    //check if i can write to this directory
    //TODO
    
    find_db_ids(pp);
    qq:=pp;
    while qq<>nil do
    begin
      str(qq^.nr,s);
      assign(t,paramstr(3)+s+'.rex');
      rewrite(t);
      writeln(stderr,'Dumping database #',qq^.nr,'...');
      dump_database(t,qq^.nr);
      close(t);
      writeln(stderr,'Database #',qq^.nr,' writen');
      qq:=qq^.next;
    end;
    destroy_db_ids(pp);
    close_rex;
    exit;
  end;
  for i:=2 to paramcount do
  begin
    val(paramstr(i),db,k);
    if k>0 then
      writeln(stderr,'Invalid parameter: ',paramstr(i)) else
      dump_database(stdout,db);
  end;
  close_rex;
end.